/*
 * Helma License Notice
 *
 * The contents of this file are subject to the Helma License
 * Version 2.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://adele.helma.org/download/helma/license.txt
 *
 * Copyright 1998-2003 Helma Software. All Rights Reserved.
 *
 * $RCSfile$
 * $Author$
 * $Revision$
 * $Date$
 */

package helma.util;

import java.io.FileInputStream;

/**
 * class with byte data of helma logo
 */
public class Logo {
    public static final byte[] hop = {
                                         71, 73, 70, 56, 57, 97, -82, 0, 35, 0, -60, 0, 0,
                                         -1, -1, -1, -17, -17, -17, -33, -33, -33, -52,
                                         -52, -52, -67, -67, -67, -84, -84, -84, -103,
                                         -103, -103, -119, -119, -119, 120, 120, 120, 102,
                                         102, 102, 84, 84, 84, 67, 67, 67, 51, 51, 51, 33,
                                         33, 33, 18, 18, 18, 0, 0, 0, -2, 1, 2, 0, 0, 0, 0,
                                         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                         0, 0, 0, 0, 0, 0, 0, 33, -7, 4, 4, 20, 0, -1, 0,
                                         44, 0, 0, 0, 0, -82, 0, 35, 0, 0, 5, -1, 32, 32,
                                         -114, 100, 105, -98, 104, -86, -82, 108, -21, -66,
                                         112, 44, -49, 116, 109, -33, 120, -82, -45, -61,
                                         -79, 52, -114, 96, 67, 113, 24, -20, -114, -56,
                                         -92, -78, 21, 32, 32, 22, -63, -121, 116, 74, 109,
                                         44, -118, -127, -91, 118, -53, 125, 5, 122, 63, 7,
                                         117, 76, -106, 58, -84, -40, -82, 122, -83, 28,
                                         24, -62, -27, -72, -4, 113, 78, 20, -78, -20, -68,
                                         -34, 21, 40, 36, 24, 98, 115, -126, -126, 14, 12,
                                         8, 4, 120, 123, -118, 122, 2, 5, 10, -127, -125,
                                         -111, -111, 117, -120, -117, -106, 92, 5, -128,
                                         -110, -101, -100, -123, 4, -105, -96, 72, 4, 64,
                                         -100, -91, -110, 103, 70, -95, -86, 55, 9, -112,
                                         83, 12, 11, 12, -111, 86, 11, -90, 100, 14, 9, 47,
                                         4, 4, 2, 57, 77, -107, 55, -69, -67, 36, -65,
                                         -119, 42, 2, -69, 54, -78, 100, -97, 4, -111, 8,
                                         34, -74, 100, 12, 47, 82, -48, 36, -50, 15, -97,
                                         -70, 82, -37, 54, -42, 37, -39, -37, -75, 11, 40,
                                         8, 82, 54, -82, 83, 34, -25, -125, -51, -46, 99,
                                         14, 46, -30, 37, -19, -58, 44, -19, 56, -12, 36,
                                         -7, -47, 15, -41, 38, -56, -91, -101, 38, 34, -63,
                                         -126, 90, 85, -96, 76, -55, 114, 96, -116, -107,
                                         6, 15, -84, -72, 114, 112, 80, -99, -68, 19, -55,
                                         70, 52, 124, 48, -128, -41, 8, 100, -34, 0, 16,
                                         72, -11, 17, 24, 0, 5, 15, -88, -1, -91, 64, 118,
                                         -49, -60, -58, -114, -61, 78, -90, 28, 33, -116,
                                         -90, 55, 49, 9, 58, -34, 27, 105, -94, 35, 9, 117,
                                         15, 114, 1, -64, 51, -64, 76, 1, 17, 1, 106, 53,
                                         40, 40, -91, -41, -80, 0, 6, -112, 66, 124, 112,
                                         -128, 4, -54, 41, 23, 73, 24, 8, -60, 0, 79, 2,
                                         51, 82, -114, 2, -112, -91, 64, 68, -127, 64, 101,
                                         -121, 34, 116, 96, 100, -86, 20, -110, 34, 32, 78,
                                         117, -48, -53, 64, 83, 1, 82, -86, 126, -91, 19,
                                         54, 110, 80, 17, 118, 57, 2, 24, 48, 87, 0, 94,
                                         -66, 116, -122, -99, -107, -110, 86, -82, -108,
                                         68, 64, -85, 2, 64, -112, 10, -30, 81, 3, -48,
                                         -20, -90, -107, 117, -111, 64, 84, 0, 5, -60, -18,
                                         69, -96, 96, 65, -81, 108, 102, -62, -47, 41, 0,
                                         81, -78, -84, 6, 8, -60, -108, 3, 0, -82, -88, 3,
                                         -42, 15, 122, -43, -6, -13, 15, -76, -75, -112,
                                         67, -91, 44, 24, 61, -103, -114, 111, 109, 99, 35,
                                         -58, 126, 80, 46, 64, 94, 118, -24, 0, -120, 65,
                                         32, -117, 64, 1, 41, 9, -82, 70, -75, -115, 91,
                                         -128, -13, -120, 7, 127, 50, 19, -39, -101, -10,
                                         108, -118, -28, -81, 9, 23, 17, 30, 64, 123, -124,
                                         -122, 14, -111, -57, 90, -94, 22, 52, -5, -2, -96,
                                         -111, -99, -1, 9, 127, -83, 93, -113, 61, 17, -43,
                                         62, -40, 116, -13, 93, 85, 2, -11, 3, -50, -1,
                                         126, -5, 8, -108, -51, 23, -120, -28, 67, -113,
                                         127, -38, 16, 56, 2, 80, 34, 52, -12, 73, 81, 81,
                                         5, 32, -33, 57, 27, -126, 35, -35, 53, 14, -112,
                                         72, 85, 9, 27, -91, -10, 81, 95, -32, 100, 115,
                                         20, 56, 27, 5, 112, -104, 2, -7, 124, -91, -46, 8,
                                         -3, -44, -13, 24, 61, -32, -44, 66, -115, -117,
                                         -76, -11, 102, 79, 126, -13, 1, -28, 99, 113, 15,
                                         -56, -56, 88, 62, 67, -106, -96, -114, 74, 95,
                                         101, 97, 87, 76, 76, -43, -43, 23, 94, 71, 97, 9,
                                         0, 94, 42, 61, -63, 20, 125, 35, 4, -10, 69, 95,
                                         27, 9, 80, -44, 3, 71, 125, -75, 84, 96, 83, 44,
                                         5, -111, 80, 35, -96, 116, -93, 85, 17, 1, 16,
                                         -29, -103, 71, -31, 100, 103, 83, 120, 2, -96,
                                         -90, 8, 103, 118, 24, -56, 103, 122, -94, -76,
                                         -90, 67, 50, 45, 101, -126, 58, 66, 49, -96, 104,
                                         108, -48, -127, -39, 78, 47, -41, 81, -102, -101,
                                         111, 85, 57, -41, 40, 21, 89, 21, 39, 79, 96, -67,
                                         -4, 9, 106, 114, 101, -99, -45, -23, -127, 37,
                                         -68, 121, 2, 68, 101, -119, 122, -41, 115, -82,
                                         94, -70, 31, 0, -127, -91, 18, 24, 93, -121, 85,
                                         -59, -86, -89, -87, 62, -112, -106, -109, 99, 72,
                                         -26, 43, 123, -77, 33, -76, -98, 123, -58, 77,
                                         118, 17, -92, -59, -67, -93, 30, -89, 36, 36, 88,
                                         39, -87, -59, 41, -38, 35, -1, 115, 5, 34, 55, 2,
                                         -86, 37, 124, -89, -33, 95, -90, 30, -9, -55, 126,
                                         -25, 88, 91, 94, -114, 72, 90, 103, -32, -75, -77,
                                         33, 37, 34, -80, 84, 56, 27, -51, 121, -80, -31,
                                         23, 100, -79, -8, -78, 119, 41, -120, -13, -127,
                                         -87, 47, 52, 16, 61, -5, 109, 46, 19, -10, -122,
                                         -39, 124, 125, 32, 112, 90, 55, 38, -120, -13, 93,
                                         84, -46, 62, 64, -92, 44, 4, 51, -116, 108, 57, 2,
                                         32, 16, 85, 55, 18, 50, -116, -33, -63, 22, 94,
                                         56, 70, -122, -56, -99, 41, 101, 91, 104, -118,
                                         32, 11, -119, 44, -117, 32, -58, 81, 61, 48, 20,
                                         15, 9, 13, 13, -111, 82, 22, -39, 40, -16, 21, 93,
                                         123, 38, -71, 39, 108, 127, 121, 123, -122, 8,
                                         -39, 32, 112, 79, 59, 6, -51, -124, 44, 115, 98,
                                         -4, -56, -40, -50, -67, 108, 36, 108, 111, -50,
                                         -40, 76, -51, -111, 67, -42, 124, 78, 46, 77, -62,
                                         43, 5, -108, 62, 7, -106, 64, 22, 3, 92, -107,
                                         -106, 93, 89, -90, -84, -27, 97, 12, -100, -106,
                                         -59, 94, 109, 18, -77, -13, -40, 36, 59, -102, 82,
                                         42, 127, -86, 69, 7, -35, -76, -54, -106, 74, 82,
                                         77, -107, -128, 18, 90, -61, 108, -107, -46, 110,
                                         123, -38, -51, 64, 42, 2, -120, -79, 84, -96, 34,
                                         -104, -99, 69, -95, -45, 2, -114, 75, 22, -122,
                                         -94, -32, 22, 60, -100, -113, 49, 103, 12, -86,
                                         -22, -80, -21, 125, 42, 48, 40, -44, -7, -23, 123,
                                         -53, 32, 0, 3, -100, -63, 101, 3, -73, -92, -69,
                                         112, -64, -26, -88, -37, -30, -119, 12, 3, 28,
                                         -108, -45, 14, -71, 47, -32, 122, -20, 43, 32, 64,
                                         74, -19, -90, 20, 34, 22, -16, -56, -65, -48,
                                         -120, -23, -60, 15, 66, -111, 1, 45, 37, 47, -3,
                                         10, -115, 40, 48, 124, -13, 85, 40, 80, 0, -107,
                                         -45, 119, -17, -123, 19, -102, -44, 94, -56, 33,
                                         -47, 123, 111, -2, -9, -44, 69, 81, -54, -8, -37,
                                         -97, -17, -66, 14, 77, 60, -95, 126, 28, 20, -111,
                                         -1, -2, -3, 109, 28, -96, 0, 32, 66, 16, 49, 64,
                                         -7, -8, 11, -96, 0, 7, -56, -122, 16, 0, 0, 59
                                     };

    /**
     * utitilty function to create byte array from file
     */
    public static void main(String[] args) throws Exception {
        FileInputStream fis = new FileInputStream(args[0]);
        byte[] b = new byte[256];
        int linect = 0;
        int ct = 0;

        System.out.print("\n\n\n  static byte[] image = {\n    ");

        while (ct > -1) {
            ct = fis.read(b);

            for (int i = 0; i < ct; i++) {
                System.out.print(b[i] + ",");
                linect++;

                if (linect > 30) {
                    linect = 0;
                    System.out.print("\n    ");
                }
            }
        }

        System.out.print("  };\n\n\n");
    }
}
